import java.util.*;

import java.sql.*;
import org.hibernate.*;
import org.hibernate.cfg.*;
import org.hibernate.criterion.*;

public class Main {
	
	public static void main(String[] args) {
		HibernateUtil.setup("create table User ( id int, username VARCHAR, activated boolean);");
		
        //insert the users
        insertUser("a",true);
        insertUser("b",true);
        insertUser("c",false);
        insertUser("e",false);
        insertUser("e",false);


        SessionFactory factory = new Configuration().configure().buildSessionFactory();
        Session session = factory.openSession();
        Transaction tx = session.beginTransaction();

        //Show all users
        System.out.println("ALL USERS");
        displayUsers(session);
        
        //Show activated users
        Filter filter = session.enableFilter("activatedFilter");
        filter.setParameter("activatedParam",new Boolean(true));
        System.out.println("ACTIVATED USERS");
        displayUsers(session);
        
        //Show non-activated users
        filter.setParameter("activatedParam",new Boolean(false));
        System.out.println("NON-ACTIVATED USERS");
        displayUsers(session);
        
        session.close();
		


        HibernateUtil.checkData("select * from User");
	}

    public static void displayUsers(Session session)
    {
        Transaction trans = session.beginTransaction();
        Query query = session.createQuery("from User");
        Iterator results = query.iterate();
        while (results.hasNext())
        {
            User user = (User) results.next();
            System.out.print(user.getUsername() + " is ");
            if (user.isActivated())
            {
                System.out.println("activated.");
            }
            else
            {
                System.out.println("not activated.");
            }
        }
            
        trans.commit();
        
    }


    public static void insertUser(String name, boolean activated)
    {
        Session session = HibernateUtil.currentSession();
        Transaction trans = session.beginTransaction();
        
        User user = new User();
        user.setUsername(name);
        user.setActivated(activated);        
        session.save(user);
        
        trans.commit();
    }

}
